﻿using System.Runtime.Remoting.Messaging;

namespace Earthworm
{
    /// <summary>
    /// 后通知接口
    /// </summary>
    public interface IAfterAdvice
    {
        /// <summary>
        /// 在方法执行后，需要进行的通知
        /// </summary>
        /// <param name="callMsg">执行完方法的返回消息</param>
        void DoAdvice(IMethodReturnMessage callMsg);
    }
    //////////////////////////////////////////////////////////////////////////
    /**示例
    /// <summary>
    /// 用户登出时间记录
    /// </summary>
    class LogoutTimeLogger:IAfterAdvice
    {
        /// <summary>
        /// 记录当前用户登出系统的时间
        /// </summary>
        /// <param name="callMsg">执行完方法的返回消息</param>
        public void DoAdvice(IMethodReturnMessage callMsg)
        {
            if (callMsg == null)
            {
                return;
            }
            Log.Write(string.Format("用户:{0}于{1}登出此系统", User.CurrentUser.Name, DateTime.Now.ToString()));
        }
    }
    **/
    //////////////////////////////////////////////////////////////////////////
}

