﻿using System.Runtime.Remoting.Messaging;

namespace Earthworm
{
    /// <summary>
    /// 前通知接口
    /// </summary>
    public interface IBeforeAdvice
    {
        /// <summary>
        /// 在方法执行前，需要进行的通知
        /// </summary>
        /// <param name="callMsg">要执行方法的调用消息</param>
        void DoAdvice(IMethodCallMessage callMsg);
    }
    //////////////////////////////////////////////////////////////////////////
    /**示例
    /// <summary>
    /// 用户登录时间记录对象
    /// </summary>
    class LoginTimeLogger:IBeforeAdvice
    {
        /// <summary>
        /// 记录当前用户登录到系统的时间
        /// </summary>
        /// <param name="callMsg">要执行方法的调用消息</param>
        public void DoAdvice(IMethodCallMessage callMsg)
        {
            if (callMsg==null)
            {
                return;
            }
             Log.Write(string.Format("用户:{0}于{1}登陆到此系统", User.CurrentUser.Name, DateTime.Now.ToString()));
        }
    }
    **/
    //////////////////////////////////////////////////////////////////////////
}
