﻿using Earthworm;
namespace EarthwormDemo
{
    /// <summary>
    /// 检查对象权限，可以在用户进行关键操作的方法前
    /// </summary>
    sealed class CheckPermission:IStopAdvice
    {
        /// <summary>
        /// 检查当前用户的权限
        /// 如果是管理员则可以继续执行方法
        /// 否则不能执行
        /// </summary>
        /// <param name="msg">要执行方法的调用消息</param>
        /// <returns>是管理员返回true,否则为false</returns>
        public bool CanContinueMethod(System.Runtime.Remoting.Messaging.IMethodCallMessage msg)
        {
            if (User.CurrentUser.IsAdministrator)
                return true;
            else
            {
                System.Windows.Forms.MessageBox.Show("你没有权限！");
                return false;
            }
        }
    }
}
