﻿using System.Collections.Generic;
using Earthworm;

namespace EarthwormDemo
{
    /// <summary>
    /// 检查通知提供
    /// </summary>
    class CheckProvider : IAdviceProvider
    {
        private Dictionary<string, IStopAdvice> stopAdvices = new Dictionary<string, IStopAdvice>();
        /// <summary>
        /// 构造函数
        /// </summary>
        public CheckProvider()
        {
            stopAdvices.Add("Delect", new CheckPermission());
        }
        /// <summary>
        /// 不相关，null
        /// </summary>
        public Dictionary<string, IBeforeAdvice> BeforeAdvices
        {
            get { return null; }
        }
        /// <summary>
        /// 设置了监视Delete方法
        /// </summary>
        public Dictionary<string, IStopAdvice> StopAdvices
        {
            get { return stopAdvices; }
        }
        /// <summary>
        /// 不相关，null
        /// </summary>
        public Dictionary<string, IAfterAdvice> AfterAdvices
        {
            get { return null; }
        }
    }
}
