﻿using System;
using System.Collections.Generic;
using System.Text;
using Earthworm;
using System.Runtime.Remoting.Messaging;

namespace EarthwormDemo
{
    /// <summary>
    /// 日志建议
    /// </summary>
    class LoggerAdvice:IBeforeAdvice,IAfterAdvice
    {
        /// <summary>
        /// 记录当前用户登录到系统的时间
        /// </summary>
        /// <param name="callMsg">要执行方法的调用消息</param>
        public void DoAdvice(IMethodCallMessage callMsg)
        {
            if (callMsg == null)
            {
                return;
            }
            Log.Write(string.Format("用户:{0}于{1}登陆到此系统", ((User)(callMsg.Args[0])).Name, DateTime.Now.ToString()));
        }
        /// <summary>
        /// 记录当前登出系统的时间
        /// </summary>
        /// <param name="callMsg">执行完方法的返回消息</param>
        public void DoAdvice(IMethodReturnMessage callMsg)
        {
            if (callMsg == null)
            {
                return;
            }
            Log.Write(string.Format("{0}登出此系统", DateTime.Now.ToString()));
        }
    }
}
