﻿using System.Collections.Generic;
using Earthworm;

namespace EarthwormDemo
{
    /// <summary>
    /// 日志通知提供对象
    /// </summary>
    class LoggerProvider:IAdviceProvider
    {
        private Dictionary<string, IBeforeAdvice> beforeAdvices = new Dictionary<string, IBeforeAdvice>();
        private Dictionary<string, IAfterAdvice> afterAdvices = new Dictionary<string, IAfterAdvice>();
        /// <summary>
        /// 必须包含无参构造函数
        /// </summary>
        public LoggerProvider()
        {
            LoggerAdvice la = new LoggerAdvice();
            //将SetCurrectUser作为前通知方法
            beforeAdvices.Add("SetCurrectUser", la);
            //将Logout作为后通知方法
            afterAdvices.Add("Logout", la);
        }
        /// <summary>
        /// 前通知集合
        /// </summary>
        public Dictionary<string, IBeforeAdvice> BeforeAdvices
        {
            get { return beforeAdvices; }
        }
        /// <summary>
        /// 拦截通知集合，与日志无关，不返回任何信息
        /// </summary>
        public Dictionary<string, IStopAdvice> StopAdvices
        {
            get { return null; }
        }
        /// <summary>
        /// 后通知集合
        /// </summary>
        public Dictionary<string, IAfterAdvice> AfterAdvices
        {
            get { return afterAdvices; }
        }
    }
}
