﻿
using Earthworm;
namespace EarthwormDemo
{
    /// <summary>
    /// 用户
    /// </summary>
    [AspectOriented("EarthwormDemo.exe", "EarthwormDemo.LoggerProvider")]
    class User:AspectOrientedObject
    {
        /// <summary>
        /// 用户名
        /// </summary>
        public string Name { get;private set; }
        /// <summary>
        /// 密码，demo而已没有做加密之类神马的东东
        /// </summary>
        public string Psd { get; private set; }
        /// <summary>
        /// 是否是管理员
        /// </summary>
        public bool IsAdministrator
        {
            get
            {
                //(*^__^*) 嘻嘻
                //Monk是管理员哦，其他都不是
                if (Name == "Monk")
                {
                    return true;
                }
                return false;
            }
        }
        /// <summary>
        /// 构造函数
        /// </summary>
        public User(){}
        /// <summary>
        /// 构造函数
        /// </summary>
        /// <param name="name">用户名</param>
        /// <param name="psd">密码</param>
        public User(string name,string psd)
        {
            Name = name;
            Psd = psd;
        }
        /// <summary>
        /// 这样做是为了能得到一个非静态方法
        /// AspectOrientedObject不支持静态方法
        /// </summary>
        /// <param name="u">用户</param>
        private void SetCurrectUser(User u)
        {
            if(currentUser.Name==null)
                currentUser=u;
        }
        /// <summary>
        /// 当前用户实例
        /// </summary>
        private static User currentUser = new User();
        /// <summary>
        /// 当前用户实例，不安全的设置方法，没有lock哦
        /// </summary>
        public static User CurrentUser 
        {
            get
            {
                return currentUser;
            }
            set
            {
                currentUser.SetCurrectUser(value);
            }
        }
        /// <summary>
        /// 退出系统
        /// </summary>
        public void Logout()
        {
            currentUser = null;
        }
    }
}
